# Neural network robustness verification via Linear Programming

[![pipeline status](https://gitlab1.ptb.de/ludwig10_masters_thesis/lp_nn_robustness_verification/badges/main/pipeline.svg)](https://gitlab1.ptb.de/ludwig10_masters_thesis/lp_nn_robustness_verification/-/commits/main)
[![Latest Release](https://img.shields.io/github/v/release/BjoernLudwigPTB/lp_nn_robustness_verification?label=Latest%20release)](https://github.com/BjoernLudwigPTB/lp_nn_robustness_verification/releases/latest)
[![DOI](https://zenodo.org/badge/587113361.svg)](https://zenodo.org/badge/latestdoi/587113361)

This is the code written in conjunction with the second part of [the author's Master's 
thesis on GUM-compliant neural network robustness
verification](https://gitlab1.ptb.de/ludwig10_masters_thesis/gum-compliant_neural_network_robustness_verification).
The code was written for _Python 3.10_.

The final submission date was 23. January 2023.

## Getting started

The [INSTALL guide](INSTALL.md) assists in installing the required packages.
After that you might want to have a look at our
[examples](https://github.com/BjoernLudwigPTB/lp_nn_robustness_verification/tree/main/src/lp_nn_robustness_verification/examples)
and/or the provided 
[notebook](https://github.com/BjoernLudwigPTB/lp_nn_robustness_verification/blob/main/src/lp_nn_robustness_verification/examples/linear_inclusion.ipynb)
to get a feeling for how to use the software.

## Documentation

To locally build the HTML or pdf documentation first the required dependencies need 
to be installed into your virtual environment (check the [INSTALL guide](INSTALL.md) 
first and upon completion execute the following):

```shell
(venv) $ python -m piptools sync docs-requirements.txt
(venv) $ sphinx-build docs/ docs/_build
sphinx-build docs/ docs/_build
Running Sphinx v5.3.0
loading pickled environment... done
[...]
The HTML pages are in docs/_build.
```

After that the documentation can be viewed by opening the file
_docs/\_build/index.html_ in any browser.

## Roadmap

- check what improvements are made by switching to optimizable variables for the $r_i$ s

## Disclaimer

This software is developed under the sole responsibility of [Björn
Ludwig](https://github.com/BjoernLudwigPTB) (the author in the following). The 
software is made available "as is" free of cost. The author assumes no 
responsibility whatsoever for its use by other parties, and makes no guarantees, 
expressed or implied, about its quality, reliability, safety, suitability or any 
other characteristic. In no event will the author be liable for any direct, indirect or 
consequential damage arising in connection with the use of this software.

## License

lp_nn_robustness_verification is distributed under the [MIT
license](https://github.com/BjoernLudwigPTB/lp_nn_robustness_verification/blob/main/LICENSE).